package de.hhu.ba.yoshikoWrapper.core;

import java.util.HashMap;
import java.util.List;

import org.cytoscape.application.CyApplicationManager;
import org.cytoscape.model.CyColumn;
import org.cytoscape.model.CyEdge;
import org.cytoscape.model.CyNetwork;
import org.cytoscape.model.CyNode;
import org.cytoscape.model.CyRow;

import de.hhu.ba.yoshikoWrapper.swig.LibraryInterface;
import de.hhu.ba.yoshikoWrapper.swig.SWIGTYPE_p_yskInput__LibraryInput;

public class NetworkParser {
	
	//**TODO MAKE DYNAMIC
	private static String weightIndex = "Weight";
	

	
	
	public static SWIGTYPE_p_yskInput__LibraryInput parseNetwork(CyNetwork net,NodeMap nodeMap) {
		SWIGTYPE_p_yskInput__LibraryInput generatedInput = LibraryInterface.new_LibraryInput();
		if (net != null){			
			LibraryInterface.LibraryInput_setSize(generatedInput,  net.getNodeCount());
			List<CyEdge> edges = net.getEdgeList();
			Class<?> weightType = net.getDefaultEdgeTable().getColumn(weightIndex).getType();
			System.out.println("Column has type:"+weightType.getName());
			for (CyEdge e : edges) {
				CyRow edgeEntry = net.getRow(e);
				double weight = 0.0;
				if (weightType == Integer.class) {
					weight = (double)edgeEntry.get(weightIndex, Integer.class);
				}
				System.out.println("Found Edge: "+edgeEntry.get("name", String.class)+ "with weight:"+weight);
				
				LibraryInterface.LibraryInput_addEdge(generatedInput,
						nodeMap.get(e.getSource()),
						nodeMap.get(e.getTarget())
						, weight);
				
			}
		}
		return generatedInput;
	}



	


}
